%global maven_version 4.0.17.Final-redhat-1
%global maven_repo_dir %{_javadir}/maven-repo
%global __jar_repack 0

Name: netty-all-amq
Version:        4.0.17
Release:	3%{?dist}
License:        ASL 2.0
Summary:	Asynchronous event-driven network application framework
Group:		Development/Java
URL:		http://www.netty.io/
Source0: netty-example-4.0.17.Final-redhat-1-sources.jar
Source1: netty-example-4.0.17.Final-redhat-1.jar
Source2: netty-example-4.0.17.Final-redhat-1.pom
Source3: netty-transport-sctp-4.0.17.Final-redhat-1.jar
Source4: netty-transport-sctp-4.0.17.Final-redhat-1.pom
Source5: netty-transport-sctp-4.0.17.Final-redhat-1-sources.jar
Source6: netty-all-4.0.17.Final-redhat-1.jar
Source7: netty-all-4.0.17.Final-redhat-1-sources.jar
Source8: netty-all-4.0.17.Final-redhat-1.pom
Source10: netty-parent-4.0.17.Final-redhat-1.pom
Source11: netty-transport-udt-4.0.17.Final-redhat-1.jar
Source12: netty-transport-udt-4.0.17.Final-redhat-1.pom
Source13: netty-transport-udt-4.0.17.Final-redhat-1-sources.jar
Source14: netty-codec-socks-4.0.17.Final-redhat-1-sources.jar
Source15: netty-codec-socks-4.0.17.Final-redhat-1.pom
Source16: netty-codec-socks-4.0.17.Final-redhat-1.jar
Source17: netty-tarball-4.0.17.Final-redhat-1.pom
Source18: netty-common-4.0.17.Final-redhat-1.pom
Source19: netty-common-4.0.17.Final-redhat-1-sources.jar
Source20: netty-common-4.0.17.Final-redhat-1.jar
Source21: netty-buffer-4.0.17.Final-redhat-1-sources.jar
Source22: netty-buffer-4.0.17.Final-redhat-1.pom
Source23: netty-buffer-4.0.17.Final-redhat-1.jar
Source24: netty-microbench-4.0.17.Final-redhat-1.pom
Source25: netty-microbench-4.0.17.Final-redhat-1.jar
Source26: netty-codec-http-4.0.17.Final-redhat-1.jar
Source27: netty-codec-http-4.0.17.Final-redhat-1-sources.jar
Source28: netty-codec-http-4.0.17.Final-redhat-1.pom
Source29: netty-testsuite-4.0.17.Final-redhat-1.pom
Source30: netty-testsuite-4.0.17.Final-redhat-1.jar
Source31: netty-testsuite-4.0.17.Final-redhat-1-tests.jar
Source32: netty-handler-4.0.17.Final-redhat-1.pom
Source33: netty-handler-4.0.17.Final-redhat-1-sources.jar
Source34: netty-handler-4.0.17.Final-redhat-1.jar
Source35: netty-transport-rxtx-4.0.17.Final-redhat-1-sources.jar
Source36: netty-transport-rxtx-4.0.17.Final-redhat-1.jar
Source37: netty-transport-rxtx-4.0.17.Final-redhat-1.pom
Source38: netty-codec-4.0.17.Final-redhat-1-sources.jar
Source39: netty-codec-4.0.17.Final-redhat-1.pom
Source40: netty-codec-4.0.17.Final-redhat-1.jar
Source41: netty-transport-4.0.17.Final-redhat-1.pom
Source42: netty-transport-4.0.17.Final-redhat-1.jar
Source43: netty-transport-4.0.17.Final-redhat-1-sources.jar
Source100:      netty-parent-%{maven_version}-scm-sources.zip 
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch: 	noarch

%description
Netty is an asynchronous event-driven network application framework for rapid development of maintainable high performance protocol servers & clients. 

%package maven-repo
Summary:        Asynchronous event-driven network application framework
Group:          Development/Java
Requires:       netty-all-amq = %{version}-%{release}

%description maven-repo
Maven repository for netty-all.

%prep
%setup -q -T -b 100 -n netty-%{version}.Final

%build

%install
rm -rf %{buildroot}

function maven_checksums() {
  local FILEPATH=$1
  local DESTFILE=$2
  if [ -z "$DESTFILE" ]; then
    DESTFILE=$FILEPATH
  fi
  md5sum $FILEPATH | cut -d' ' -f1 > $DESTFILE.md5
  sha1sum $FILEPATH | cut -d' ' -f1 > $DESTFILE.sha1
}

function populate_maven_repo() {
  local POMPATH=$1
  local POMDIR=${POMPATH%/*}
  local POMFILE=${POMPATH##*/}
  local JARBASE=${POMFILE%.pom}
  %{__mkdir_p} %{buildroot}%{maven_repo_dir}/$POMDIR
  %{__install} -pm 644 %{_sourcedir}/$POMFILE \
                       %{buildroot}%{maven_repo_dir}/$POMDIR
  maven_checksums %{buildroot}%{maven_repo_dir}/$POMDIR/$POMFILE
  local VERSION=${POMDIR##*/}
  local PARENTDIR=${POMDIR%/*}
  local ARTIFACTID=${PARENTDIR##*/}
  local GROUPPATH=${PARENTDIR%/*}
  local GROUPID=${GROUPPATH//\//.}
  cat > %{buildroot}%{maven_repo_dir}/$PARENTDIR/maven-metadata.xml <<EOF
<metadata>
  <groupId>$GROUPID</groupId>
  <artifactId>$ARTIFACTID</artifactId>
  <versioning>
    <release>$VERSION</release>
    <versions>
      <version>$VERSION</version>
    </versions>
    <lastUpdated>$(date +%%Y%%m%%d%%H%%M%%S)</lastUpdated>
  </versioning>
</metadata>
EOF
  maven_checksums %{buildroot}%{maven_repo_dir}/$PARENTDIR/maven-metadata.xml
  for jarpath in %{buildroot}%{_javadir}/%{name}-%{version}/$JARBASE*.jar; do
    if [ -f $jarpath ]; then
      JARFILE=$(basename $jarpath)
      ln -s %{_javadir}/%{name}-%{version}/$JARFILE \
            %{buildroot}%{maven_repo_dir}/$POMDIR/$JARFILE
      maven_checksums %{buildroot}%{_javadir}/%{name}-%{version}/$JARFILE \
        %{buildroot}%{maven_repo_dir}/$POMDIR/$JARFILE
    fi
  done
}

%{__install} -dm 755 %{buildroot}%{_javadir}
%{__install} -dm 755 %{buildroot}%{_javadir}/%{name}-%{version}

%{__install} -pm 644 %{SOURCE6} %{buildroot}%{_javadir}/%{name}-%{version}
%{__install} -pm 644 %{SOURCE7} %{buildroot}%{_javadir}/%{name}-%{version}

populate_maven_repo io/netty/netty-all/4.0.17.Final-redhat-1/netty-all-4.0.17.Final-redhat-1.pom
populate_maven_repo io/netty/netty-parent/4.0.17.Final-redhat-1/netty-parent-4.0.17.Final-redhat-1.pom

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%dir %{_javadir}/%{name}-%{version}
%{_javadir}/%{name}-%{version}/*.jar
%doc LICENSE.txt
%doc README.md
%doc NOTICE.txt

%files maven-repo
%defattr(-,root,root,-)
%{maven_repo_dir}

%changelog
* Tue Jul 21 2015 Irina Boverman <iboverma@redhat.com> - 4.0.17.Final-3
- Corrected dependencies

* Mon Jul 20 2015 Irina Boverman <iboverma@redhat.com> - 4.0.17.Final-2
- Updated dependencies

* Fri Jun  3 2015 Irina Boverman <iboverma@redhat.com> - 4.0.17.Final-1
- Initial build
